/*
 * Copyright 2015 JBoss Inc
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package org.optaplanner.core.impl.heuristic.selector.common.iterator;

import java.util.ListIterator;

public abstract class SelectionListIterator<S> implements ListIterator<S> {

    public void remove() {
        throw new UnsupportedOperationException("The optional operation remove() is not supported.");
    }

    public void set(Object o) {
        throw new UnsupportedOperationException("The optional operation set(...) is not supported.");
    }

    public void add(Object o) {
        throw new UnsupportedOperationException("The optional operation add(...) is not supported.");
    }

}
